Subject: Re: FVWM: Cannot maximize while iconified?

From: John Latham <[email-masked]>
Date: Tue, 20 Aug 2002 15:51:09 +0100

> From: Dominik Vogt <[email-masked]>
> Date: Tue, 13 Aug 2002 00:15:29 +0200

> On Mon, Aug 12, 2002 at 06:26:12PM +0100, John Latham wrote:
> > I had a bit of configuration that maximised an iconified window and then
> > de-iconified it. This stopped working in 2.4: the maximise was seeming to have
> > no effect. When I swapped the order round it works okay. I wanted to do the
> > maximise while the window was iconified so that there was less `flickering' on
> > the screen, but it is not a major issue.

> >From the ChangeLog (pre 2.4):

> 2000-06-15  Dominik Vogt  <[email-masked]>

> 	* fvwm/builtins.c (WindowShade):
> 	* fvwm/move_resize.c (Maximize):
> 	(resize_window):
> 	don't maximize/shade/resize iconified windows

> No idea why I did this.  I'll revert back to the old way.

Thank you very much.

> > While on this matter, can anyone suggest a better way of achieving the effect
> > I want? It is for the middle mouse button when clicked on the task bar window
> > buttons. If I move along the task bar pressing the middle mouse button on each
> > window button then I want to see each window in turn maximised, with all the
> > others returned to normal, and a second click on the last button returns that
> > window to normal too.
> > 
> > Viz:    Unmaximise the previous maximised window.
> >         Move to the desktop / page where this window is.
> >         Maximise / demaxmimise it, and focus it.
> > 
> > After much fiddling I previously arrived at:
> > 
> > *FvwmTaskBarAction Click2 Focus,Iconify 1,Prev [!FvwmTaskBar Maximized
> > !Iconic] Maximize 100 97,Maximize 100 97,Iconify -1,Focus

> You shouldn't use comma separated action lists anymore.  Each of
> the commands might be applied to a different window, screwing up
> the whole desktop.  It's safer to use a complex function.

Ooops - I missed that warning in the 2.4 FvwmTaskBar man page. May I suggest
that fvwm24_convert might produce a warning for this? I used the observations
``it is working or not'' and then the fvwm24_convert script to drive my
upgrade process; and I didn't reread every man page! Naughty me... Thanks for
pointing it out.

> Also,
> the brackets around contitions are obsolete.  This is no problem
> with the configuration, but should anyone ever look at this config
> (s)he shouldn't be encouraged to use brackets.  Instead, use
> parentheses.

My apologies: I forgot to convert it for the example. The reason I use the old
syntax is that I try to make AnotherLevelUp backwards compatable with FVWM
2.0, and wish to keep the FVWM version-specific parts to a minimum. (I know of
at least once person who still uses it on a default Red Hat 5.1 installation.)

> Now to answer the question.  This setup should work more reliable:

>   Style FvwmTaskBar WindowListSkip, CirculateSkip
>   *FvwmTaskBarAction Click2 Silent Function TB2Func

>   SetEnv TB2FuncWin 0
>   AddToFunc TB2Func
>   + I WindowId $w (!maximized) TB2Activate
>   + I WindowId $[TB2FuncWin] (maximized, !iconic) TB2Deactivate
>   + I WindowId $w (!maximized, iconic) TB2Activate2
>   + I SetEnv TB2FuncWin $w

>   AddToFunc TB2Activate
>   + I Iconify on

>   AddToFunc TB2Activate2
>   + I Focus
>   + I Maximize on 100 97
>   + I Iconify off

>   AddToFunc TB2Deactivate
>   + I Maximize off

> The only problem is that this setup doesn't work well if you
> iconify a window while it's maximized.

That's great thanks: I'll use this approach for FVWM 2.4 onwards.

> > Since 2.4 I have had to swap the last Maximize and Iconify to make it work
> > again:
> > 
> > *FvwmTaskBarAction Click2 Focus,Iconify 1,Prev [!FvwmTaskBar Maximized
> > !Iconic] Maximize 100 97,Iconify -1,Maximize 100 97,Focus
>
> Bye
>
> Dominik ^_^  ^_^

Best wishes, John Latham
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].